// C Source File
// Created 8/9/01; 5:00:21 PM
// By Ty Taylor

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File





#define MAX_UNITS 150
#define MAX_BUILDINGS 50
#define MAX_ORDERS 50
#define MAX_TRIGGERS 25
#define MAX_TIBERIUM 200
#define MAX_TERRAIN 2000
#define MAX_BRIEFING 1000
#define MAX_TOBUILDS 30


//MAP
#define MAX_HEIGHT 64
#define MAX_WIDTH 64


#define UNIT_VALUES 29
#define UNITTYPE_VALUES 14
#define BULLET_VALUES 12

#define NUMBER_OF_TYPES_OF_UNITS 34

#define NUMBER_OF_BUILDING_PICS 67
#define NUMBER_OF_UNIT_PICS 214

//unittype numbers
#define COMM 12
#define PROC 11
#define NUKE 1
#define WEAP 8
#define YARD 0
#define PYLE 7
#define SILO 10
#define TOWR 3
#define ATWR 4
#define OBLI 6
#define BAY 9
#define NUK2 2

#define LASER 12


#define HARV 24
#define LTNK 18
#define MTNK 19
#define MINI 13
#define BTNK 22  //mammoth tank

//orders
#define MOVETO 1
#define GOTOORDER 2
#define ATTACKUNITS 3


//triggers
#define ALLDEAD 1
#define GAMETIME 2
#define UNITDEAD 3


#define VICTORY 1
#define DEFEAT 2
#define ORDERUNIT 3


unsigned short cursor[32] = 
{0xFC3F,0x8001,0x8001,0x8001,0x8001,0x8001,0x0000,0x0000,
0x0000,0x0000,0x8001,0x8001,0x8001,0x8001,0x8001,0xFC3F,
0xFC3F,0x8001,0x8001,0x8001,0x8001,0x8001,0x0000,0x0000,
0x0000,0x0000,0x8001,0x8001,0x8001,0x8001,0x8001,0xFC3F};//select box


struct teams
{
	int order, n1, t1, n2, t2, n3, t3, n4, t4, n5, t5; 
};

struct triggers
{
	int cause, cvalue,cause2, cvalue2, effect, evalue;
};


struct orders
{
	int order, x, y;
};

struct unittype
{
	int pic, width, height;
};

struct unit
{
	int col,row,direction,type,side,hp,trigger;
};


struct tobuild
{
	int col,row,type;
};


struct building
{
	int col,row,type,side,hp,trigger;
};

struct terrain
{
	char col,row,type;
};

struct tiberium
{
	char col,row,type;
};


	int curmapx=0, curmapy=0, mapwidth=32, mapheight=32, money=0, enemymoney=0, techlevel=1, yourside=0;


struct terrain *(allterrain)=NULL;



int checkscr(int x,int y)
{
	if(x/16<curmapx||x/16>curmapx+9||y/16<curmapy||y/16>curmapy+5)  return FALSE;
	return TRUE;
}


void GraySprite16(int x, int y, unsigned short *sprite, int side)
{
	if(checkscr(x,y)){
	
	if(side==0){
	Sprite16(x-curmapx*16,y-curmapy*16,16,sprite,GetPlane(DARK_PLANE),SPRT_XOR);
	Sprite16(x-curmapx*16,y-curmapy*16,16,sprite+16,GetPlane(LIGHT_PLANE),SPRT_XOR);
	}
	
	if(side==1){
	Sprite16(x-curmapx*16,y-curmapy*16,16,sprite+16,GetPlane(DARK_PLANE),SPRT_XOR);
	Sprite16(x-curmapx*16,y-curmapy*16,16,sprite,GetPlane(LIGHT_PLANE),SPRT_XOR);
	}
	
	}
}

void CursorSprite16(int x, int y, unsigned short *sprite)
{
	Sprite16(x,y,16,sprite,GetPlane(DARK_PLANE),SPRT_XOR);
	Sprite16(x,y,16,sprite+16,GetPlane(LIGHT_PLANE),SPRT_XOR);
}



void clrgrayscr()
{
		SetPlane(LIGHT_PLANE);
		clrscr();
		SetPlane(DARK_PLANE);
		clrscr();	
}
		


int changenum(int *num, int x, int y)
	{
		int i,key;
		char temp1[15];
		
		DrawStr(x-8,y,">",4);
		do
		{
		key=ngetchx();
			
			if(key>='0'&&key<='9'&& *(num) < 10000)
			{
				
				*(num)*=10; 
				*(num)+=key-48;
				i++;
				
				sprintf(temp1,"%d   ",*(num));
				DrawStr(x,y,temp1,4);
			}
			
			if(key== KEY_BACKSPACE)
			{
				*(num)/=10;
				sprintf(temp1,"%d   ",*(num));
				DrawStr(x,y,temp1,4);
			}
			
		
			
			
		}while(key!=264&&key!=13);
		DrawStr(x-8,y," ",4);
	return key;
		
	}
	
	

 void DrawInt( int x, int y, int num, int mode)
 {
 	char str[15];
 	sprintf(str,"%d",num);
 	DrawStr(x,y,str,mode);
 	
 }




int InputStr (char *buffer, short maxlen)
{
  int j=0;
  SCR_STATE ss;
  short key, i = strlen(buffer);
  //buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      //if message is really long put in new screen
      	j=286*(i/286);
      	if(i==286||i==572||i==858) clrscr();
      
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_  ", buffer+j);
        // Note that two spaces are required if F_4x6 font is used
      key = ngetchx ();
      if (key >= ' ' && key <= 255 && i < maxlen) buffer[i++] = key;
      if (key == KEY_BACKSPACE && i) i--;
      buffer[i] = 0;
    } while (key != KEY_ENTER&&key!=KEY_ESC);
return key;
}


void GrayPix(int x, int y, int color)
{
	switch(color)
	{
		case 0: 
		SetPlane(LIGHT_PLANE);
		DrawPix(x,y,2);
		break;
		
		case 1: 
		SetPlane(DARK_PLANE);
		DrawPix(x,y,2);
		break;
		
		SetPlane(DARK_PLANE);
		
	}
	
}





// Main Function
void _main(void)
{
	
	int col=0,row=0,key=0,redraw=0,i=0,x=0,y=0,j=0;
	int curside=0;
	int cunit=13,cterrain=-1;
	int enemyside=1;

	
	struct unittype allunittypes[NUMBER_OF_TYPES_OF_UNITS]=
	{
		{4,3,2},
		{0,2,2},
		{44,2,2},
		{72,0,0},
		{73,0,0},
		{32,0,0},
		{82,0,0},
		{32,2,2},
		{10,3,3},
		{38,3,2},
		{36,2,1},
		{19,3,3},		
		{28,2,2},
		{24,0,0},
		{56,0,0},
		{107,0,0},
		{48,0,0},
		{115,0,0},
		{83,0,0},
		{64,0,0},
		{0,0,0},
		{8,0,0},
		{40,0,0},
		{74,0,0},
		{91,0,0},
		{99,0,0},
		{16,0,0},
		{123,0,0},
		{131,0,0},
		{48,2,2},
		{52,3,3},
		{61,3,2},
		{139,0,0},
		{139,0,0}
				
	};
	
	
	struct teams allteams[10]={};
	struct triggers alltriggers[MAX_TRIGGERS]={};
	struct orders allorders[MAX_ORDERS]={};
	
	struct tobuild alltobuilds[MAX_TOBUILDS]={};
	struct unit allunits[MAX_UNITS]={};
	struct building allbuildings[MAX_BUILDINGS]={};
	struct tiberium alltiberium[MAX_TIBERIUM]={};

	char briefing[MAX_BRIEFING]=" @";
	

	unsigned short *pics;

	char name[10],TIOSname[12];
	HSym hsym;
	FILE *f;

	
	allterrain = calloc (MAX_TERRAIN, sizeof(*allterrain)); 

	
	for(i=0;i<MAX_TERRAIN;i++)
	{
		allterrain[i].col=-1;
	}
	
	for(i=0;i<MAX_TIBERIUM;i++)
	{
		alltiberium[i].col=-1;
	}
	
	for(i=0;i<MAX_TOBUILDS;i++)
	{
		alltobuilds[i].col=-1;
	}
	
	for(i=0;i<MAX_UNITS;i++)
	{
		allunits[i].col=-1;
		allunits[i].hp=100;
		allunits[i].direction=255;
	}
	
	for(i=0;i<MAX_BUILDINGS;i++)
	{
		allbuildings[i].col=-1;
		allbuildings[i].hp=100;
	}
	
	
	
	//pointer to picture data		
		pics=((unsigned short*)HeapDeref(SymFindPtr($(ctc2gfx),0)->handle))+1+19*8+4*32+10*32+11*32;


	ClrScr();
	
	GrayOn();
	
	clrgrayscr();
	CursorSprite16(col*16,row*16,cursor);
	
	while((key=ngetchx())!=4360)
	{
	CursorSprite16(col*16,row*16,cursor);
	
	if(key==KEY_LEFT&&col+curmapx>0) col--;
	if(key==KEY_RIGHT&&col+curmapx<mapwidth-1) col++;
	if(key==KEY_DOWN&&row+curmapy<mapheight-1) row++;
	if(key==KEY_UP&&row+curmapy>0) row--;
	
	//2nd + arrows faster move
	if(key==4433)
	{
		redraw=1;
		curmapy-=6;
	}
	if(key==4440)
	{
		redraw=1;
		curmapx+=10;
	}
	if(key==4436)
	{
		redraw=1;
		curmapy+=6;
	}
	if(key==4434)
	{
		redraw=1;
		curmapx-=10;
	}
	
	if(curmapx>mapwidth-10) curmapx=mapwidth-10;
	if(curmapx<0) curmapx=0;
	if(curmapy>mapheight-6) curmapy=mapwidth-6;
	if(curmapy<0) curmapy=0;
	

	
	//load
	if(key=='4')
	{
		clrgrayscr();
		
		DrawStr(0,10,"LOAD Name?",4);

		i=0;
		redraw=1;
		
		j=InputStr(name, 8);
		
		
			if(j!=KEY_ESC&&(f = fopen (name, "rb")))
		{
			DrawStr(53,20,"Loading...",2);

		for(i=0;i<MAX_TERRAIN;i++)
	{
		allterrain[i].col=-1;
	}
	
	for(i=0;i<MAX_TIBERIUM;i++)
	{
		alltiberium[i].col=-1;
	}
	
	for(i=0;i<MAX_TOBUILDS;i++)
	{
		alltobuilds[i].col=-1;
	}
	
	for(i=0;i<MAX_UNITS;i++)
	{
		allunits[i].col=-1;
		allunits[i].hp=100;
		allunits[i].direction=255;
	}
	
	for(i=0;i<MAX_BUILDINGS;i++)
	{
		allbuildings[i].col=-1;
		allbuildings[i].hp=100;
	}


	fread(&j,2,1,f);
	fread(&briefing,1,j,f);
	
	fread(&mapwidth,2,1,f);
	fread(&mapheight,2,1,f);
	fread(&curmapx,2,1,f);
	fread(&curmapy,2,1,f);
	fread(&yourside,2,1,f);
	fread(&money,2,1,f);
	fread(&enemymoney,2,1,f);
	fread(&techlevel,2,1,f);
		
	fread(&j,2,1,f);
	fread(&allteams[0].order,2,j*11,f);
	
	fread(&j,2,1,f);
	fread(&allorders[0].order,2,j*3,f);

	fread(&j,2,1,f);
	fread(&alltriggers[0].cause,2,j*6,f);
	
	fread(&j,2,1,f);
	fread(&alltobuilds[0].col,2,j*3,f);
	
/*
	for(i=0;i<j;i++)
	{
		fread(&x,2,1,f);
		allterrain[i].col=x;
		fread(&x,2,1,f);
		allterrain[i].row=x;
		fread(&x,2,1,f);
		allterrain[i].type=x;
	}

	fread(&j,2,1,f);
	for(i=0;i<j;i++)
	{
		fread(&x,2,1,f);
		alltiberium[i].col=x;
		fread(&x,2,1,f);
		alltiberium[i].row=x;
		fread(&x,2,1,f);
		alltiberium[i].type=x;
	}
*/
	fread(&j,2,1,f);
	fread(&allterrain[0].col,1,j*3,f);
	
	fread(&j,2,1,f);
	fread(&alltiberium[0].col,1,j*3,f);
	
	
	fread(&j,2,1,f);
	fread(&allbuildings[0].col,2,j*6,f);
	
	fread(&j,2,1,f);
	fread(&allunits[0].col,2,j*7,f);

	fclose(f);

	strcat(briefing,"@");
	
		}
		else
		{
			DrawStr(41,80,"BAD FILE NAME",4);
			ngetchx();
		}

		
	}
	
	
	
	
	
	
	
	//ssave
	if(key=='3')
	{
		clrgrayscr();
	
		DrawStr(0,10,"SAVE Name?",4);
		
		i=0;
		redraw=1;
		
		j=InputStr(name, 8);
		
		//save map as "name"
		
		TIOSname[0] = 0;	
		hsym = SymFind (strcpy (TIOSname + 1, name) + strlen (name));
		EM_moveSymFromExtMem (NULL, hsym); 
		
		if(j!=KEY_ESC&&(f = fopen (name, "wb")))
	{


DrawStr(53,20,"Saving...",2);

j=5;

for(j=0;j<MAX_BRIEFING-1;j++)
{
	if(briefing[j]=='@')
	{
		break;
	}
}



	fwrite(&j,2,1,f);
	fwrite(&briefing,1,j,f);
	
	fwrite(&mapwidth,2,1,f);
	fwrite(&mapheight,2,1,f);
	fwrite(&curmapx,2,1,f);
	fwrite(&curmapy,2,1,f);
	fwrite(&yourside,2,1,f);
	fwrite(&money,2,1,f);
	fwrite(&enemymoney,2,1,f);
	fwrite(&techlevel,2,1,f);
	

	x=0;
	for(j=1;j<9;j++)
	{
		if(allteams[j].order==0)
		{
			x++;
		}
		if(x>=2) break;
	}
	
	fwrite(&j,2,1,f);
	fwrite(&allteams[0].order,2,j*11,f);
	

	
	for(j=1;j<MAX_ORDERS;j++)
	{
		if(allorders[j].order==0&&allorders[j].x==0)
		{
			break;
		}
	}
	
	fwrite(&j,2,1,f);
	fwrite(&allorders[0].order,2,j*3,f);
	

	
	for(j=1;j<MAX_TRIGGERS;j++)
	{
		if(alltriggers[j].cause==0&&alltriggers[j].cause2==0)
		{
			break;
		}
	}	
	
	fwrite(&j,2,1,f);
	fwrite(&alltriggers[0].cause,2,j*6,f);
	

	
	for(j=1;j<MAX_TOBUILDS;j++)
	{
		if(alltobuilds[j].col<0)
		{
			break;
		}
	}
	
	
	
	fwrite(&j,2,1,f);
	fwrite(&alltobuilds[0].col,2,j*3,f);


	do{
	x=0;	
	for(j=0;j<MAX_TERRAIN-1;j++)
	{
		if(allterrain[j].col<0&&allterrain[j+1].col>=0)
		{
			allterrain[j].col=allterrain[j+1].col;
			allterrain[j].row=allterrain[j+1].row;
			allterrain[j].type=allterrain[j+1].type;
			allterrain[j+1].col=-1;
			x=1;
		}
	}
	}while(x==1);
	

	for(j=1;j<MAX_TERRAIN;j++)
	{
		if(allterrain[j].col<0)
		{
			break;
		}
	}
	
	if(allterrain[0].col<0)
	{
		allterrain[0].col=0;
		allterrain[0].row=0;
		allterrain[0].type=0;
	}
	
	
	fwrite(&j,2,1,f);
	fwrite(&allterrain[0].col,1,j*3,f);
	
	do{
	x=0;
	for(j=0;j<MAX_TIBERIUM-1;j++)
	{
		if(alltiberium[j].col<0&&alltiberium[j+1].col>=0)
		{
			alltiberium[j].col=alltiberium[j+1].col;
			alltiberium[j].row=alltiberium[j+1].row;
			alltiberium[j].type=alltiberium[j+1].type;
			alltiberium[j+1].col=-1;
			x=1;
		}
	}
	}while(x==1);
	
	for(j=1;j<MAX_TIBERIUM;j++)
	{
		if(alltiberium[j].col<0)
		{
			break;
		}
	}
	if(alltiberium[0].col<0)
	{
		alltiberium[0].col=0;
		alltiberium[0].row=0;
		alltiberium[0].type=0;
	}
	
	
	fwrite(&j,2,1,f);
	fwrite(&alltiberium[0].col,1,j*3,f);
	
	
	do{
	x=0;
	for(j=0;j<MAX_BUILDINGS-1;j++)
	{
		if(allbuildings[j].col<0&&allbuildings[j+1].col>=0)
		{
			allbuildings[j].col=allbuildings[j+1].col;
			allbuildings[j].row=allbuildings[j+1].row;
			allbuildings[j].type=allbuildings[j+1].type;
			allbuildings[j].hp=allbuildings[j+1].hp;
			allbuildings[j].trigger=allbuildings[j+1].trigger;
			allbuildings[j].side=allbuildings[j+1].side;			
			allbuildings[j+1].col=-1;
			x=1;
			
		}
	}
	}while(x==1);
	
	for(j=1;j<MAX_BUILDINGS;j++)
	{
		if(allbuildings[j].col<0)
		{
			break;
		}
	}
	
	
	fwrite(&j,2,1,f);
	fwrite(&allbuildings[0].col,2,j*6,f);

	do{
	x=0;	
	for(j=0;j<MAX_UNITS-1;j++)
	{
		if(allunits[j].col<0&&allunits[j+1].col>=0)
		{
			allunits[j].col=allunits[j+1].col;
			allunits[j].row=allunits[j+1].row;
			allunits[j].type=allunits[j+1].type;
			allunits[j].hp=allunits[j+1].hp;
			allunits[j].trigger=allunits[j+1].trigger;
			allunits[j].side=allunits[j+1].side;			
			allunits[j].direction=allunits[j+1].direction;						
			allunits[j+1].col=-1;
			x=1;	
		}
	}
	}while(x==1);
	
	for(j=1;j<MAX_UNITS;j++)
	{
		if(allunits[j].col<0)
		{
			break;
		}
	}
	

	
	fwrite(&j,2,1,f);
	fwrite(&allunits[0].col,2,j*7,f);


	
	
	
	fputc (0, f);
	fputs ("Level for CTC2", f);
	fputc (0, f);
	fputc (STR_TAG, f);
DrawStr(100,80,"f5",2);
	fclose(f);

		
		DrawStr(26,80,"SAVED SUCCESSFULLY",4);
		
		
		hsym = SymFind (strcpy (TIOSname + 1, name) + strlen (name));
		EM_moveSymToExtMem (NULL, hsym); 
		
	}
	else
		{
			DrawStr(41,80,"BAD FILE NAME",4);
			ngetchx();
		}
		
	
	}
	
	
	
	
	
	
	//briefing
	if(key=='t')
	{
		clrgrayscr();
		InputStr(briefing,MAX_BRIEFING-2);
		strcat(briefing,"@");
		redraw=1;		
	}
	
	
	
	
	//build teams
	if(key=='z')
	{
		clrgrayscr();
		
		j=0;
		
		DrawStr(0,0,"Team #",2);
		
		DrawInt(50,0,j,2);
		
		changenum(&j,50,0);
		
		DrawInt(50,0,j,2);
		
		if(j>=10) j=9;
		
		DrawInt(50,0,j,4);
		
		DrawStr(0,10,"Order",2);
		DrawStr(0,20,"1N",2);
		DrawStr(0,30,"1T",2);
		DrawStr(0,40,"2N",2);
		DrawStr(0,50,"2T",2);
		DrawStr(80,0,"3N",2);
		DrawStr(80,10,"3T",2);
		DrawStr(80,20,"4N",2);
		DrawStr(80,30,"4T",2);
		DrawStr(80,40,"5N",2);
		DrawStr(80,50,"5T",2);
		
		
		
		
		FontSetSys(0);
		
		DrawStr(0,60,"#N is number of.  #T is type",2);
		DrawStr(0,67,"13=MG 14=G 15=FT 16=RM 17=ENG 18=HUMM",2);
		DrawStr(0,74,"19=RECON 20=LTNK 21=MTNK 22=FTNK 23=ART",2);
		DrawStr(0,81,"24=MAMM 25=MRLS 26=HARV 27=MCV 28=CMD",2);

		
		FontSetSys(1);
		
		
		DrawInt(50,10,allteams[j].order,2);
		DrawInt(50,20,allteams[j].n1,2);
		DrawInt(50,30,allteams[j].t1,2);
		DrawInt(50,40,allteams[j].n2,2);
		DrawInt(50,50,allteams[j].t2,2);
		DrawInt(130,0,allteams[j].n3,2);
		DrawInt(130,10,allteams[j].t3,2);
		DrawInt(130,20,allteams[j].n4,2);
		DrawInt(130,30,allteams[j].t4,2);
		DrawInt(130,40,allteams[j].n5,2);
		DrawInt(130,50,allteams[j].t5,2);
		
		i=changenum(&allteams[j].order,50,10);
		if(i!=KEY_ESC)i=changenum(&allteams[j].n1,50,20);
		if(i!=KEY_ESC)i=changenum(&allteams[j].t1,50,30);
		if(i!=KEY_ESC)i=changenum(&allteams[j].n2,50,40);
		if(i!=KEY_ESC)i=changenum(&allteams[j].t2,50,50);
		if(i!=KEY_ESC)i=changenum(&allteams[j].n3,130,0);
		if(i!=KEY_ESC)i=changenum(&allteams[j].t3,130,10);
		if(i!=KEY_ESC)i=changenum(&allteams[j].n4,130,20);
		if(i!=KEY_ESC)i=changenum(&allteams[j].t4,130,30);
		if(i!=KEY_ESC)i=changenum(&allteams[j].n5,130,40);
		if(i!=KEY_ESC)i=changenum(&allteams[j].t5,130,50);
		
		
		redraw=1;
	}
	
	
	
	//triggers
	if(key=='y')
	{
		clrgrayscr();
		
		j=0;
		
		DrawStr(0,0,"Trigger#",2);
		
		DrawInt(60,0,j,2);
		
		changenum(&j,60,0);
		
		DrawInt(60,0,j,2);
		
		if(j>=MAX_TRIGGERS) j=MAX_TRIGGERS-1;
		
		DrawInt(60,0,j,4);
		
		DrawStr(0,10,"Cause",2);
		DrawStr(0,20,"Cvalue",2);
		DrawStr(0,30,"Cause2",2);
		DrawStr(0,40,"Cvalue2",2);
		DrawStr(0,50,"Effect",2);
		DrawStr(0,60,"Evalue",2);
		
		
		DrawStr(80,0,"For Cause",2);
		
		FontSetSys(0);
		
		DrawStr(80,10,"1=ALL DEAD",2);
		DrawStr(80,16,"2=GAME TIME",2);
		DrawStr(80,22,"3=UNIT DEAD",2);
		DrawStr(80,28,"4=ENEMY MONEY",2);
		DrawStr(80,34,"5=CAPTURE",2);
		DrawStr(80,40,"6=DESTINATION",2);
		DrawStr(80,46,"7=BUILD UNIT",2);
		DrawStr(80,52,"8=MONEY",2);
		DrawStr(80,58,"9=INTERVAL",2);
		
		
		DrawStr(0,70,"1=VICTORY",2);
		DrawStr(0,76,"2=DEFEAT",2);
		DrawStr(0,82,"3=ORDER UNIT",2);
		DrawStr(0,88,"4=ADD EMONEY",2);
		DrawStr(0,94,"5=FLARE",2);
		DrawStr(80,70,"6=ALLOWVICTORY",2);
		DrawStr(80,76,"7=E REINFORCEMENT",2);
		DrawStr(80,82,"8=REINFORCEMENT",2);
		DrawStr(80,88,"9=IN GAME MESSEGE",2);
		DrawStr(80,94,"10=ADD MONEY",2);
		
		FontSetSys(1);
		
		
		DrawInt(50,10,alltriggers[j].cause,2);
		DrawInt(50,20,alltriggers[j].cvalue,2);
		DrawInt(50,30,alltriggers[j].cause2,2);
		DrawInt(50,40,alltriggers[j].cvalue2,2);
		DrawInt(50,50,alltriggers[j].effect,2);
		DrawInt(50,60,alltriggers[j].evalue,2);
		
		i=changenum(&alltriggers[j].cause,50,10);
		if(i!=KEY_ESC)i=changenum(&alltriggers[j].cvalue,50,20);
		if(i!=KEY_ESC)i=changenum(&alltriggers[j].cause2,50,30);
		if(i!=KEY_ESC)i=changenum(&alltriggers[j].cvalue2,50,40);
		if(i!=KEY_ESC)i=changenum(&alltriggers[j].effect,50,50);
		if(i!=KEY_ESC)i=changenum(&alltriggers[j].evalue,50,60);
		
		
		redraw=1;
	}
	
	
	
	//orders
	if(key=='x')
	{
		clrgrayscr();
		
		j=0;
		
		DrawStr(0,0,"Order #",2);
		
		DrawInt(50,0,j,2);
		
		changenum(&j,50,0);
		
		DrawInt(50,0,j,2);
		
		if(j<1) j=1;
		if(j>=MAX_ORDERS) j=MAX_ORDERS-1;
		
		DrawInt(50,0,j,4);
		
		DrawStr(0,10,"Type",2);
		DrawStr(0,20,"X",2);
		DrawStr(0,30,"Y",2);
		
		
		DrawStr(80,0,"For Type",2);
		
		FontSetSys(0);
		
		DrawStr(80,10,"1=MOVE TO",2);
		DrawStr(80,16,"X & Y are dest",2);
		DrawStr(80,30,"2=GOTO ORDER",2);
		DrawStr(80,36,"X is order #",2);
		DrawStr(80,50,"3=ATTACK UNITS",2);
		DrawStr(80,56,"X & Y =0",2);
		
		FontSetSys(1);
		
		DrawInt(40,10,allorders[j].order,2);
		DrawInt(40,20,allorders[j].x,2);
		DrawInt(40,30,allorders[j].y,2);
		
		i=changenum(&allorders[j].order,40,10);
		if(i!=KEY_ESC)i=changenum(&allorders[j].x,40,20);
		if(i!=KEY_ESC)i=changenum(&allorders[j].y,40,30);
		
		redraw=1;
	}
	
	
	//change map values
	if(key==KEY_APPS)
	{	
		clrgrayscr();
		
		DrawStr(50,0,"MAP VALUES",2);
		
		DrawStr(0,20,"Map Width",2);
		DrawStr(0,30,"Map Height",2);
		DrawStr(0,40,"Money",2);
		DrawStr(0,50,"Enemy Money",2);
		DrawStr(0,60,"Tech Level",2);
		DrawStr(0,70,"Your Side",2);
		
		DrawInt(80,20,mapwidth,2);
		DrawInt(80,30,mapheight,2);
		DrawInt(80,40,money,2);
		DrawInt(80,50,enemymoney,2);
		DrawInt(80,60,techlevel,2);
		DrawInt(80,70,yourside,2);
		
		DrawStr(110,60,"(1-11)",2);
		DrawStr(110,20,"(1-64)",2);
		DrawStr(110,30,"(1-64)",2);
		DrawStr(110,70,"(0=GDI",2);
		DrawStr(110,80,"1=NOD)",2);
		
		j=changenum(&mapwidth,80,20);
		if(j!=KEY_ESC)j=changenum(&mapheight,80,30);
		if(j!=KEY_ESC)j=changenum(&money,80,40);
		if(j!=KEY_ESC)j=changenum(&enemymoney,80,50);
		if(j!=KEY_ESC)j=changenum(&techlevel,80,60);
		if(j!=KEY_ESC)j=changenum(&yourside,80,70);
		
		if(mapwidth>64) mapwidth=64;
		if(mapheight>64) mapheight=64;
		if(yourside>1) yourside=1;
		
		if(yourside==0) enemyside=1;
		else enemyside=0;
		
		redraw=1;
		
	}
	
	
	if(key==KEY_CLEAR)
	{
		for(i=0;i<MAX_UNITS;i++)
		{
			if(allunits[i].col==col+curmapx&&allunits[i].row==row+curmapy)allunits[i].col=-1;
		}
		for(i=0;i<MAX_TOBUILDS;i++)
		{
			if(alltobuilds[i].col==col+curmapx&&alltobuilds[i].row==row+curmapy)alltobuilds[i].col=-1;
		}
		for(i=0;i<MAX_BUILDINGS;i++)
		{
			if(allbuildings[i].col==col+curmapx&&allbuildings[i].row==row+curmapy)allbuildings[i].col=-1;
		}
		for(i=0;i<MAX_TERRAIN;i++)
		{
			if(allterrain[i].col==col+curmapx&&allterrain[i].row==row+curmapy)allterrain[i].col=-1;
		}
		for(i=0;i<MAX_TIBERIUM;i++)
		{
			if(alltiberium[i].col==col+curmapx&&alltiberium[i].row==row+curmapy)alltiberium[i].col=-1;
		}
	redraw=1;
		
	}
	
	
	//find coords of square
	if(key==KEY_F5)
	{
		DrawInt(0,90,col+curmapx,1);
		DrawInt(15,90,row+curmapy,1);
	}
	
	
	//put a to build building
	if(key==KEY_F3&&(allunittypes[cunit].width>0||cunit<13))
	{
		for(i=0;i<MAX_TOBUILDS;i++)
		{
			if(alltobuilds[i].col==col+curmapx&&alltobuilds[i].row==row+curmapy)
			break;
		}
		
		if(i==MAX_TOBUILDS){
		for(i=0;i<MAX_TOBUILDS;i++)
		{
			if(alltobuilds[i].col<0) break;
		}
		alltobuilds[i].col=col+curmapx;
		alltobuilds[i].row=row+curmapy;
		alltobuilds[i].type=cunit;
		redraw=1;
		}	
		
		
	}
	
	
	
	
	
	
	
	//put a unit
	if(key==KEY_F2)
	{
		
		if(allunittypes[cunit].width>0)
		{
		for(i=0;i<MAX_BUILDINGS;i++)
		{
			if(allbuildings[i].col==col+curmapx&&allbuildings[i].row==row+curmapy)
			break;
		}
		
		if(i==MAX_BUILDINGS){
		for(i=0;i<MAX_BUILDINGS;i++)
		{
			if(allbuildings[i].col<0) break;
		}
		allbuildings[i].col=col+curmapx;
		allbuildings[i].row=row+curmapy;
		allbuildings[i].type=cunit;
		allbuildings[i].side=curside;
		redraw=1;
		
		clrgrayscr();
		
		DrawStr(47,0,"UNIT VALUES",2);
		
		DrawStr(0,40,"Side",2);
		DrawStr(0,60,"Trigger",2);
		DrawStr(0,80,"HP %",2);
		
		DrawInt(80,40,allbuildings[i].side,2);
		DrawInt(80,60,allbuildings[i].trigger,2);
		DrawInt(80,80,allbuildings[i].hp,2);
		
		DrawStr(110,40,"(0=GDI",2);
		DrawStr(110,50,"1=NOD)",2);
		
		j=changenum(&allbuildings[i].side,80,40);
		if(j!=KEY_ESC)j=changenum(&allbuildings[i].trigger,80,60);
		if(j!=KEY_ESC)j=changenum(&allbuildings[i].hp,80,80);
		
		if(allbuildings[i].side>1) allbuildings[i].side=1;
		curside=allbuildings[i].side;
			
		}
		}
	
	
	
		else{
		
		for(i=0;i<MAX_UNITS;i++)
		{
			if(allunits[i].col==col+curmapx&&allunits[i].row==row+curmapy)
			break;
		}
		
		if(i==MAX_UNITS){
		for(i=0;i<MAX_UNITS;i++)
		{
			if(allunits[i].col<0) break;
		}
		allunits[i].col=col+curmapx;
		allunits[i].row=row+curmapy;
		allunits[i].type=cunit;
		allunits[i].side=curside;
		redraw=1;
		
		clrgrayscr();
		
		DrawStr(47,0,"UNIT VALUES",2);
		
		DrawStr(0,20,"Side",2);
		DrawStr(0,40,"Trigger",2);
		DrawStr(0,60,"HP %",2);
		DrawStr(0,80,"Direction",2);
		
		DrawInt(80,20,allunits[i].side,2);
		DrawInt(80,40,allunits[i].trigger,2);
		DrawInt(80,60,allunits[i].hp,2);
		DrawInt(80,80,allunits[i].direction,2);
		
		DrawStr(110,20,"(0=GDI",2);
		DrawStr(110,30,"1=NOD)",2);
		DrawStr(110,80,"(255=N",2);
		DrawStr(110,90,"450=45*)",2);
		
		j=changenum(&allunits[i].side,80,20);
		if(j!=KEY_ESC)j=changenum(&allunits[i].trigger,80,40);
		if(j!=KEY_ESC)j=changenum(&allunits[i].hp,80,60);
		if(j!=KEY_ESC)j=changenum(&allunits[i].direction,80,80);
		
		if(allunits[i].side>1) allunits[i].side=1;
		curside=allunits[i].side;
		
		}
		
		}
		
	}
	
	
	//put terrain
	if(key==KEY_F1)
	{
		if(cterrain==-9||cterrain==-10||cterrain==-11)
		{

		for(i=0;i<MAX_TIBERIUM;i++)
		{
			if(alltiberium[i].col==col+curmapx&&alltiberium[i].row==row+curmapy)
			break;	
		}
		
		if(i==MAX_TIBERIUM){
		for(i=0;i<MAX_TIBERIUM;i++)
		{
			if(alltiberium[i].col<0) break;
		}
		alltiberium[i].col=col+curmapx;
		alltiberium[i].row=row+curmapy;
		alltiberium[i].type=cterrain*(-1)-1;
		redraw=1;
		}
			
		}
		else{
		
		for(i=0;i<MAX_TERRAIN;i++)
		{
			if(allterrain[i].col==col+curmapx&&allterrain[i].row==row+curmapy)
			break;	
		}
		
		if(i==MAX_TERRAIN){
		for(i=0;i<MAX_TERRAIN;i++)
		{
			if(allterrain[i].col<0) break;
		}
		allterrain[i].col=col+curmapx;
		allterrain[i].row=row+curmapy;
		allterrain[i].type=cterrain;
		redraw=1;
		}
		
		}
		
	}
	
	
	
	
	
	//select type of unit
	if(key==KEY_MODE) 
	{
		clrgrayscr();
	x=0;
	y=0;
	
	CursorSprite16(x*16,y*16,cursor);
	
	for(i=0;i<NUMBER_OF_TYPES_OF_UNITS;i++)
	{
		if(allunittypes[i].width==0)
		CursorSprite16(x*16,y*16,pics+32*(NUMBER_OF_BUILDING_PICS+(allunittypes[i].pic)));
		else
		CursorSprite16(x*16,y*16,pics+32*(allunittypes[i].pic));
		
		x++;
		if(x==10)
		{
			x=0;
			y++;
		}
		
		
	}
	
	x=0;
	y=0;
		
	while((key=ngetchx())!=KEY_F2)
	{	
	CursorSprite16(x*16,y*16,cursor);
	
	
		if(key==KEY_LEFT&&x==0)	x=9;
		else{ if(key==KEY_LEFT&&x>0)	x--;
		}
		
		if(key==KEY_RIGHT&&x==9)	x=0;
		else {if(key==KEY_RIGHT&&x<9)	x++;
		}
		
		if(key==KEY_UP&&y==0)	y=5;
		else{ if(key==KEY_UP&&y>0)	y--;
		}
		
		if(key==KEY_DOWN&&y==5)	y=0;
		else{ if(key==KEY_DOWN&&y<5)	y++;
		}
		
	CursorSprite16(x*16,y*16,cursor);
	
	}
	
	cunit=((10*y+x));
	if(cunit>NUMBER_OF_TYPES_OF_UNITS-1) cunit=NUMBER_OF_TYPES_OF_UNITS-1;
	
	redraw=1;	
	}
	
	
	
	
	//select type of terrain
	if(key==277) //HOME
	{
		clrgrayscr();
	x=0;
	y=0;
	
	CursorSprite16(x*16,y*16,cursor);
	
	for(i=-1;i>-48;i--)
	{
		CursorSprite16(x*16,y*16,pics+32*(NUMBER_OF_UNIT_PICS+((i*(-1)-1))));
		x++;
		if(x==10)
		{
			x=0;
			y++;
		}
		
	}
	
	x=0;
	y=0;
		
	while((key=ngetchx())!=KEY_F1)
	{	
	CursorSprite16(x*16,y*16,cursor);
	
	
		if(key==KEY_LEFT&&x==0)	x=9;
		else{ if(key==KEY_LEFT&&x>0)	x--;
		}
		
		if(key==KEY_RIGHT&&x==9)	x=0;
		else {if(key==KEY_RIGHT&&x<9)	x++;
		}
		
		if(key==KEY_UP&&y==0)	y=5;
		else{ if(key==KEY_UP&&y>0)	y--;
		}
		
		if(key==KEY_DOWN&&y==5)	y=0;
		else{ if(key==KEY_DOWN&&y<5)	y++;
		}
		
	CursorSprite16(x*16,y*16,cursor);
	
	}
		
	cterrain=((10*y+x+1)*(-1));	
	
	redraw=1;	
	}
	
	
	
	
	if(col+curmapx<curmapx)
	{
		col++;
		redraw=1;
		curmapx--;
	}
	if(col+curmapx>curmapx+9)
	{
		col--;
		redraw=1;
		curmapx++;
	}
	if(row+curmapy<curmapy)
	{
		row++;
		redraw=1;
		curmapy--;
	}
	if(row+curmapy>curmapy+5)
	{
		row--;
		redraw=1;
		curmapy++;
	}
	

	
	//redraw screen
	if(redraw==1)
	{
		redraw=0;
		clrgrayscr();

SetPlane(LIGHT_PLANE);
DrawLine(curmapx,curmapy,curmapx+9,curmapy,1);
DrawLine(curmapx+9,curmapy,curmapx+9,curmapy+5,1);
DrawLine(curmapx,curmapy,curmapx,curmapy+5,1);
DrawLine(curmapx,curmapy+5,curmapx+9,curmapy+5,1);
DrawLine(mapwidth,0,mapwidth,mapheight,2);
DrawLine(0,mapheight,mapwidth-1,mapheight,2);

SetPlane(DARK_PLANE);
		//mini map				
		DrawLine(mapwidth,0,mapwidth,mapheight,2);
		DrawLine(0,mapheight,mapwidth-1,mapheight,2);
	
		for(i=0;i<MAX_TERRAIN;i++)
		{
			if(allterrain[i].col>=0){	
			GraySprite16(allterrain[i].col*16,allterrain[i].row*16,pics+32*(NUMBER_OF_UNIT_PICS+((allterrain[i].type*(-1)-1))),0);
			GrayPix(allterrain[i].col,allterrain[i].row,0);
			}
		}
		
		
		for(i=0;i<MAX_TIBERIUM;i++)
		{
			if(alltiberium[i].col>=0){	
			GraySprite16(alltiberium[i].col*16,alltiberium[i].row*16,pics+32*(NUMBER_OF_UNIT_PICS+((alltiberium[i].type))),0);
			GrayPix(alltiberium[i].col,alltiberium[i].row,0);
			}
		}
		
		for(i=0;i<MAX_UNITS;i++)
		{
			if(allunits[i].col>=0){	
			GraySprite16(allunits[i].col*16,allunits[i].row*16,pics+32*(NUMBER_OF_BUILDING_PICS+((allunittypes[allunits[i].type].pic+allunits[i].direction/450))),allunits[i].side);
			GrayPix(allunits[i].col,allunits[i].row,1);
			}
		}
		
		for(i=0;i<MAX_BUILDINGS;i++)
		{
			if(allbuildings[i].col>=0)	
			{
			j=0;
				for(y=allbuildings[i].row;y<allbuildings[i].row+allunittypes[allbuildings[i].type].height;y++)
				{
					for(x=allbuildings[i].col;x<allbuildings[i].col+allunittypes[allbuildings[i].type].width;x++)
					{
						GraySprite16(x*16,y*16,pics+32*(allunittypes[allbuildings[i].type].pic+j),allbuildings[i].side);
						GrayPix(x,y,1);

						j++;
					}	
				}
			}
			
			
		}
		
	
	
	for(i=0;i<MAX_TOBUILDS;i++)
		{
			if(alltobuilds[i].col>=0)	
			{
			
			if(allunittypes[alltobuilds[i].type].width>0){
			j=0;
				for(y=alltobuilds[i].row;y<alltobuilds[i].row+allunittypes[alltobuilds[i].type].height;y++)
				{
					for(x=alltobuilds[i].col;x<alltobuilds[i].col+allunittypes[alltobuilds[i].type].width;x++)
					{
						if(checkscr(x*16,y*16))  Sprite16(x*16-curmapx*16,y*16-curmapy*16,16,pics+32*(allunittypes[alltobuilds[i].type].pic+j),GetPlane(1),0);
						GrayPix(x,y,1);
						j++;
					}	
				}
			
			}
			else{
			if(checkscr(alltobuilds[i].col*16,alltobuilds[i].row*16))  Sprite16(alltobuilds[i].col*16-curmapx*16,alltobuilds[i].row*16-curmapy*16,16,pics+32*(NUMBER_OF_BUILDING_PICS+
			((allunittypes[alltobuilds[i].type].pic))),GetPlane(1),SPRT_XOR);	
			GrayPix(alltobuilds[i].col,alltobuilds[i].row,1);
			}

			}
		}
		
	}
			
		
	CursorSprite16(col*16,row*16,cursor);	
	}
	
	GrayOff();

	free(allterrain);	
	


}
